import xml.etree.ElementTree as ET
import os.path
from model.user import MyUser
import manager

'''
Inserta un usuario en el XML correspondiente como un nuevo elemento
@param user: objeto MyUser que se va a insertar
'''
def insert(user):
    if not os.path.isfile('data/users.xml'):
        root = ET.Element('users')
        
    else:
        tree = ET.parse('data/users.xml')
        root = tree.getroot()
        
    u = ET.SubElement(root, 'user')
    ET.SubElement(u, 'id').text = str(user.getId())
    ET.SubElement(u, 'name').text = user.getName()
    ET.SubElement(u, 'username').text = user.getUsername()
    
    manager.indent(root)
    tree = ET.ElementTree(root)
    with open('data/users.xml', 'wb') as file:
        tree.write(file)
        file.close()
 
'''
Busca y retorna el objeto MyUser con el id indicado de entre los almacenados en el XML
@param idUser: identificador de usuario dado por Telegram
@return user: objeto MyUser con el usuario coincidente
'''
def findById(idUser):
    user = None
    if os.path.isfile('data/users.xml'):
        with open('data/users.xml', 'r') as file:
            tree = ET.parse(file)
            root = tree.getroot()
            for child in root.findall('user'):
                if child.find('id').text == str(idUser):
                    _id = child.find('id').text
                    name = child.find('name').text
                    username = child.find('username').text
                    
                    user = MyUser(_id, name, username)
                    break
               
            file.close()
            
    return user


